'
' -------------------------------------------------------------------
' CreateTable                            Jacques     August 4st, 2011
' 
' Create a Crc32 Hashed integer array from a list of word in a file;
' one word per line.
'
' It can then be used in IsEnglish.Inc
'
' Check for twins can be commented if it takes too long on your
' computer (100 seconds here on a 2 Ghz duo)
' -------------------------------------------------------------------
'
$ESCAPECHARS ON
$TYPECHECK ON
$INCLUDE "RAPIDQ.INC"
'
Declare Function CreateTable (sWordlistFileName As String) As Long
'
'
' ==== RAPIDQ: CRC32Z.INC ======================================================
' FreeBasic Source :
' ----------------
' function crc32z(ByVal sWord as byte ptr, i2, i3, i4) as uinteger 
'    dim as integer i, j, iW
'    dim as uinteger c = 0
'   
'    c = not c
'    i = 0 
'    iW = sWord[i]
'    While iW <> 0    ' detect terminal 0
'        c xor= iW
'        for j = 1 to 8
'            c = c shr 1 xor (&hedb88320 and -(c and 1))
'        next j 
'       i += 1
'        iW = sWord[i]
'    Wend
'    c = not c
' 
'    return c
'end function
' ------------------------------------------------------------------------------
' Compiled with FBToRqInc :
' -----------------------
DECLARE FUNCTION Cwp_CRC32Z LIB "user32" ALIAS "CallWindowProcA" ( _
          ptrCRC32Z As Long, Arg1 As Long, Arg2 As Long, Arg3 As Long, Arg4 As Long _
          ) As Long
' ----- START ASM CRC32Z -----
DefByte ArrayCRC32Z (0 To 159) = _
   {&H55, &H89, &HE5, &H83, &HEC, &H14, &H53, &HC7, &H45, &HFC, &H00, &H00,  _
    &H00, &H00, &HC7, &H45, &HF8, &H00, &H00, &H00, &H00, &HC7, &H45, &HF4,  _
    &H00, &H00, &H00, &H00, &HC7, &H45, &HF0, &H00, &H00, &H00, &H00, &HC7,  _
    &H45, &HEC, &H00, &H00, &H00, &H00, &HF7, &H55, &HEC, &HC7, &H45, &HF8,  _
    &H00, &H00, &H00, &H00, &H8B, &H45, &H08, &H03, &H45, &HF8, &H0F, &HBE,  _
    &H18, &H89, &H5D, &HF0, &H83, &H7D, &HF0, &H00, &H74, &H40, &H8B, &H5D,  _
    &HF0, &H31, &H5D, &HEC, &HC7, &H45, &HF4, &H01, &H00, &H00, &H00, &H8B,  _
    &H5D, &HEC, &HD1, &HEB, &H8B, &H45, &HEC, &H83, &HE0, &H01, &HF7, &HD8,  _
    &HB9, &H20, &H83, &HB8, &HED, &H21, &HC1, &H31, &HCB, &H89, &H5D, &HEC,  _
    &HFF, &H45, &HF4, &H83, &H7D, &HF4, &H08, &H7E, &HDE, &HFF, &H45, &HF8,  _
    &H8B, &H5D, &H08, &H03, &H5D, &HF8, &H0F, &HBE, &H0B, &H89, &H4D, &HF0,  _
    &HEB, &HBA, &HF7, &H55, &HEC, &H8B, &H4D, &HEC, &H89, &H4D, &HFC, &HEB,  _
    &H00, &H8B, &H45, &HFC, &H5B, &H89, &HEC, &H5D, &HC2, &H10, &H00, &H90,  _
    &H90, &H90, &H90, &H90}
' ----- END ASM CRC32Z -----
DefInt ptrCRC32Z = VarPtr (ArrayCRC32Z(0))
Function CRC32Z(Arg1 As Long, Arg2 As Long, Arg3 As Long, Arg4 As Long) As Long
    Result = Cwp_CRC32Z(ptrCRC32Z, Arg1, Arg2, Arg3, Arg4)
End Function
' CALL ME WITH: iRet = CRC32Z(Arg1, Arg2, Arg3, Arg4)
' ==== RAPIDQ: end of CRC32Z.INC ===============================================
'
'
'
'
'
'
' ==== RAPIDQ: CHECKFORTWINS.INC ===============================================
' FreeBasic source :
' ----------------
' Type TTWIN
'     i As Integer
'     j As Integer
'     iMax As Integer
'     jMax As Integer
' End Type
'
' Function CheckForTwins (twin As TTWIN, ByVal table As Integer ptr, ii, jj) As Integer
'     Dim as Integer n, p
'     Function = 0
'     n = twin.i
'     p = twin.j
'     While n <= twin.iMax
'         While p <= twin.jMax
'             If table[n] = table[p] Then
'                 twin.i = n
'                 twin.j = p
'                 Function = 1
'                 Exit Function
'             End If
'             p += 1
'         Wend
'         n += 1
'         p = n + 1
'     Wend
' End Function
' -----------------------------------------------------------------------------
' Compilation With FBToRQInc
'
DECLARE FUNCTION Cwp_CHECKFORTWINS LIB "user32" ALIAS "CallWindowProcA" ( _
          ptrCHECKFORTWINS As Long, Arg1 As Long, Arg2 As Long, Arg3 As Long, Arg4 As Long _
          ) As Long
' ----- START ASM CHECKFORTWINS -----
DefByte ArrayCHECKFORTWINS (0 To 159) = _
   {&H55, &H89, &HE5, &H83, &HEC, &H0C, &H53, &HC7, &H45, &HFC, &H00, &H00,  _
    &H00, &H00, &HC7, &H45, &HF8, &H00, &H00, &H00, &H00, &HC7, &H45, &HF4,  _
    &H00, &H00, &H00, &H00, &HC7, &H45, &HFC, &H00, &H00, &H00, &H00, &H8B,  _
    &H45, &H08, &H8B, &H18, &H89, &H5D, &HF8, &H8B, &H5D, &H08, &H8B, &H43,  _
    &H04, &H89, &H45, &HF4, &H8B, &H45, &H08, &H8B, &H58, &H08, &H39, &H5D,  _
    &HF8, &H7F, &H52, &H8B, &H5D, &H08, &H8B, &H43, &H0C, &H39, &H45, &HF4,  _
    &H7F, &H3B, &H8B, &H45, &HF8, &HC1, &HE0, &H02, &H8B, &H5D, &H0C, &H01,  _
    &HC3, &H8B, &H45, &HF4, &HC1, &HE0, &H02, &H8B, &H4D, &H0C, &H01, &HC1,  _
    &H8B, &H01, &H39, &H03, &H75, &H1A, &H8B, &H45, &H08, &H8B, &H5D, &HF8,  _
    &H89, &H18, &H8B, &H5D, &H08, &H8B, &H45, &HF4, &H89, &H43, &H04, &HC7,  _
    &H45, &HFC, &H01, &H00, &H00, &H00, &HEB, &H11, &HFF, &H45, &HF4, &HEB,  _
    &HBA, &HFF, &H45, &HF8, &H8B, &H45, &HF8, &H40, &H89, &H45, &HF4, &HEB,  _
    &HA3, &H8B, &H45, &HFC, &H5B, &H89, &HEC, &H5D, &HC2, &H10, &H00, &H90,  _
    &H90, &H90, &H90, &H90}
' ----- END ASM CHECKFORTWINS -----
DefInt ptrCHECKFORTWINS = VarPtr (ArrayCHECKFORTWINS(0))
Function CHECKFORTWINS(Arg1 As Long, Arg2 As Long, Arg3 As Long, Arg4 As Long) As Long
    Result = Cwp_CHECKFORTWINS(ptrCHECKFORTWINS, Arg1, Arg2, Arg3, Arg4)
End Function
' CALL ME WITH: iRet = CHECKFORTWINS(Arg1, Arg2, Arg3, Arg4)
' ==== RAPIDQ: end of CHECKFORTWINS.INC ========================================
'
Type TTWIN
    i As Integer
    j As Integer
    iMax As Integer
    jMax As Integer
End Type
'
DefStr sAppDir = Command$(0) - Application.ExeName
Dim iHashArray() As Integer
Dim slTextDictionnary As QStringList
'
' Load dictionnary word list
' --------------------------
Dim dlgOpenWordList As QOpenDialog
DefStr sOldDir, sFileWordList
dlgOpenWordList.Filter = "All Files|*.*"
dlgOpenWordList.FilterIndex = 1
sOldDir = CurDir$
dlgOpenWordList.InitialDir = sAppDir
dlgOpenWordList.Caption = "Select the word list you want to Hash"
If dlgOpenWordList.Execute Then
    sFileWordList = dlgOpenWordList.FileName
Else
    ShowMessage "You should have selected a word list file !\n\n I quit"
End If
'
ChDir sOldDir
'
CreateTable (sFileWordList)
'
' -------------------------------------------------------------
' EXIT CONSOLE
' ------------
DefStr sExit
Input "\n\n                    CR to QUIT \n\n", sExit
Application.Terminate
'
' -----------------------------------------------------------------------------
'
Function CreateTable (sWordlistFileName As String) As Long
    DefInt i
    DefStr sTmp
    ' 
    ' Load Dictionnary File (word list, one word per line)
    ' ---------------------
    If FileExists (sWordListFileName) = 0 Then
        ShowMessage ("File not found " & sWordListFileName & "\n\nGET A WORD LIST FILE\n\nI Close")
        Application.Terminate
    End If
  With slTextDictionnary
    .LoadFromFile (sWordlistFileName)
    DefInt iHashArrayItemCount = .ItemCount
    Redim iHashArray (0 To iHashArrayItemCount - 1) As Integer
    '
    ' Hashing Words to Table
    ' ----------------------
    Print "\nStart Hashing :  Timer = ";Timer;" s"
    Doevents
    For i = 0 To iHashArrayItemCount - 1
        sTmp = .Item(i)
        iHashArray(i) = CRC32z (VarPtr(sTmp), 0, 0, 0)
    Next i
    Print "End   Hashing :  Timer = ";Timer;" s"
    Print "Table of ";iHashArrayItemCount;" words hashed to an integer array done"
    '
    ' Checking for Twins
    ' ------------------
    Dim Twin as TTWIN
    DefInt iTwinCount = 0
    Print "\nCHECKING FOR TWINS ... IT CAN TAKE A WHILE\n        (106 seconds here on an Intel 2GHz duo)"
    DoEvents
    Print "Start Twins Check :  Timer = ";Timer;" s"
    Twin.iMax = .ItemCount - 2
    Twin.jMax = .ItemCount - 1
    Twin.i = 0
    Twin.j = 1
    While CheckForTwins (Twin, VarPtr(iHashArray(0)), 0, 0) <> 0
        Inc twin.j
        If twin.j = .ItemCount Then
            Inc twin.i
            If Twin.i = .Itemcount - 1 Then Exit while
            twin.j = twin.i + 1
        End If
        Inc iTwinCount
        Print "Twins : \"";.Item(twin.i);"\" and \"";.Item(twin.j);"\"  hashed both to ";Hex$(iHashArray(twin.i))
        Doevents
    Wend
    Print "End   Twins Check :  Timer = ";Timer;" s"
    Print "Total of ";iTwinCount;" Twins found"
    '
    ' Sort Table
    ' ----------
    Print "\nStart Sorting Integer Array :  Timer = ";Timer;" s"
    QuickSort(iHashArray(0), iHashArray(.ItemCount), ASCEND)
    Print "End   Sorting Integer Array :  Timer = ";Timer;" s"
    Print "Array of ";.ItemCount;" integer Sorted"
    '
    ' Save Table
    ' ----------
    Dim dlgSaveTable As QSaveDialog
    Dim fSave as QFileStream
    DefStr sOldDir
    dlgSaveTable.Filter = "All Files|*.*"
    dlgSaveTable.FilterIndex = 1
    sOldDir = CurDir$
    dlgSaveTable.InitialDir = sAppDir
    If dlgSaveTable.Execute Then
        fSave.Open(dlgSaveTable.FileName, fmCreate)
            fSave.SaveArray(iHashArray(0), 1 + Ubound(iHashArray))
        fSave.Close
        Print "\nInteger Array Saved as : \"";dlgSaveTable.FileName;"\""
    End If
    ChDir sOldDir
  End With
End Function
'
