'
' -------------------------------------------------------------------
' IsEnglish.Inc                          Jacques     August 4st, 2011
' 
' IsEnglishWord("yourword")
'    returns -1 if NOT a word of the table
'    else returns the Crc32 hashed value of the word
'
' Requires  Eowl.Tbl  in it's directory to compile, it uses resources
' Be careful about resource index if you use other resources.
' -------------------------------------------------------------------
'
Const HASHED_GB_DICO = 0
$RESOURCE HASHED_GB_DICO AS "Eowl.Tbl"
'
DIM msEnglishWords AS QMEMORYSTREAM
msEnglishWords.ExtractRes(Resource(HASHED_GB_DICO))
DefInt ptrGB = msEnglishWords.Pointer
DefInt sizeGB = msEnglishWords.Size/4
'
' ==== RAPIDQ: ISENGLISH.INC ==================================================
' FB Source Code :
' --------------
' Function IsEnglish (ByVal sWord As byte ptr, ByVal iHashArray As integer ptr, _
'                       ByVal iArraySize As Integer, i4) As Integer Export
'    Dim as Integer iMiddle, iLBound, iUBound
'    Dim As Integer iHash
'    dim as integer i, j, iW
'    dim as uinteger c
'        '
'        ' Hash word CRC32
'        ' ---------------
'        c = 0
'        c = not c
'        i = 0 
'        iW = sWord[i]
'        While iW <> 0    ' detect terminal 0
'            c xor= iW
'            for j = 1 to 8
'                c = c shr 1 xor (&hedb88320 and -(c and 1))
'            next j      
'            i += 1
'            iW = sWord[i]
'        Wend
'        iHash = not c
'        '
'        ' Search in Array
'        ' ---------------
'        iMiddle = 0
'        iLBound = 0
'        iUBound = iArraySize - 1
'        Function = -1
'        Do
'            iMiddle = (iLBound + iUBound) \ 2
'            If iHashArray[iMiddle] = iHash Then
'                Function = iMiddle
'                Exit Do
'            ElseIf iHashArray[iMiddle] < iHash Then
'                iLBound = iMiddle + 1
'            Else
'                iUBound = iMiddle - 1
'            End If
'        Loop Until iLBound > iUBound
' End Function
'
' Compiled with FBtoRqInc :
' -----------------------
'
' ==== RAPIDQ: ISENGLISH.INC ===================================================
DECLARE FUNCTION Cwp_ISENGLISH LIB "user32" ALIAS "CallWindowProcA" ( _
          ptrISENGLISH As Long, Arg1 As Long, Arg2 As Long, Arg3 As Long, Arg4 As Long _
          ) As Long
' ----- START ASM ISENGLISH -----
DefByte ArrayISENGLISH (0 To 319) = _
   {&H55, &H89, &HE5, &H83, &HEC, &H28, &H53, &HC7, &H45, &HFC, &H00, &H00,  _
    &H00, &H00, &HC7, &H45, &HF8, &H00, &H00, &H00, &H00, &HC7, &H45, &HF4,  _
    &H00, &H00, &H00, &H00, &HC7, &H45, &HF0, &H00, &H00, &H00, &H00, &HC7,  _
    &H45, &HEC, &H00, &H00, &H00, &H00, &HC7, &H45, &HE8, &H00, &H00, &H00,  _
    &H00, &HC7, &H45, &HE4, &H00, &H00, &H00, &H00, &HC7, &H45, &HE0, &H00,  _
    &H00, &H00, &H00, &HC7, &H45, &HDC, &H00, &H00, &H00, &H00, &HC7, &H45,  _
    &HD8, &H00, &H00, &H00, &H00, &HC7, &H45, &HDC, &H00, &H00, &H00, &H00,  _
    &HF7, &H55, &HDC, &HC7, &H45, &HE8, &H00, &H00, &H00, &H00, &H8B, &H45,  _
    &H08, &H03, &H45, &HE8, &H0F, &HBE, &H18, &H89, &H5D, &HE0, &H83, &H7D,  _
    &HE0, &H00, &H74, &H40, &H8B, &H5D, &HE0, &H31, &H5D, &HDC, &HC7, &H45,  _
    &HE4, &H01, &H00, &H00, &H00, &H8B, &H5D, &HDC, &HD1, &HEB, &H8B, &H45,  _
    &HDC, &H83, &HE0, &H01, &HF7, &HD8, &HB9, &H20, &H83, &HB8, &HED, &H21,  _
    &HC1, &H31, &HCB, &H89, &H5D, &HDC, &HFF, &H45, &HE4, &H83, &H7D, &HE4,  _
    &H08, &H7E, &HDE, &HFF, &H45, &HE8, &H8B, &H5D, &H08, &H03, &H5D, &HE8,  _
    &H0F, &HBE, &H0B, &H89, &H4D, &HE0, &HEB, &HBA, &H8B, &H4D, &HDC, &HF7,  _
    &HD1, &H89, &H4D, &HEC, &HC7, &H45, &HF8, &H00, &H00, &H00, &H00, &HC7,  _
    &H45, &HF4, &H00, &H00, &H00, &H00, &H8B, &H4D, &H10, &H49, &H89, &H4D,  _
    &HF0, &HC7, &H45, &HFC, &HFF, &HFF, &HFF, &HFF, &H8B, &H4D, &HF0, &H03,  _
    &H4D, &HF4, &H51, &HB9, &H02, &H00, &H00, &H00, &H58, &H99, &HF7, &HF9,  _
    &H89, &HC1, &H89, &H4D, &HF8, &H8B, &H4D, &HF8, &HC1, &HE1, &H02, &H8B,  _
    &H5D, &H0C, &H01, &HCB, &H8B, &H4D, &HEC, &H39, &H0B, &H75, &H0A, &H8B,  _
    &H4D, &HF8, &H89, &H4D, &HFC, &HEB, &H2C, &HEB, &H22, &H8B, &H4D, &HF8,  _
    &HC1, &HE1, &H02, &H8B, &H5D, &H0C, &H01, &HCB, &H8B, &H4D, &HEC, &H39,  _
    &H0B, &H7D, &H09, &H8B, &H4D, &HF8, &H41, &H89, &H4D, &HF4, &HEB, &H07,  _
    &H8B, &H4D, &HF8, &H49, &H89, &H4D, &HF0, &H8B, &H4D, &HF0, &H39, &H4D,  _
    &HF4, &H7E, &HA5, &H8B, &H45, &HFC, &H5B, &H89, &HEC, &H5D, &HC2, &H10,  _
    &H00, &H90, &H90, &H90, &H90, &H90, &H90, &H90}
' ----- END ASM ISENGLISH -----
DefInt ptrISENGLISH = VarPtr (ArrayISENGLISH(0))
Function ISENGLISH(Arg1 As Long, Arg2 As Long, Arg3 As Long, Arg4 As Long) As Long
    Result = Cwp_ISENGLISH(ptrISENGLISH, Arg1, Arg2, Arg3, Arg4)
End Function
'
' CALL ME WITH: iRet = ISENGLISH(Arg1, Arg2, Arg3, Arg4)
' ==== RAPIDQ: end of ISENGLISH.INC ===========================================
'
' Function IsEnglish (ByVal sWord As byte ptr, ByVal iHashArray As integer ptr, _
'                       ByVal iArraySize As Integer, i4) As Integer Export
'
Function IsEnglishWord (sWord As String) As Long
    DefStr ssWord = sWord
    Result = Cwp_ISENGLISH(ptrISENGLISH, VarPtr(ssWord), ptrGB, sizeGB, 0)
End Function
' -----------------------------------------------------------------------------
